django/cafes/urls.py
from django.urls import path

from . import views

app_name = "cafes"
urlpatterns = [
    path("", views.index, name="index"),
    path("<int:cafe_id>", views.detail, name="detail"),
]

django/restfulapi_refresher/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path("admin/", admin.site.urls),
    path("cafes/", include("cafes.urls")),
    path("api/cafes/", include("cafes.api_urls")),
]

django/cafes/models.py
from django.db import models

# Create your models here.
class Cafe(models.Model):
    class Meta:
        db_table = "cafe"

    def __str__(self):
        return f"{self.name} @ {self.location}"

    name = models.CharField(max_length=250, unique=True, null=False)
    map_url = models.CharField(max_length=500, null=False)
    img_url = models.CharField(max_length=500, null=False)
    location = models.CharField(max_length=250, null=False)
    seats = models.CharField(max_length=250, null=False)
    has_toilet = models.BooleanField(null=False)
    has_wifi = models.BooleanField(null=False)
    has_sockets = models.BooleanField(null=False)
    can_take_calls = models.BooleanField(null=False)
    coffee_price = models.CharField(max_length=250, null=True)

django/cafes/views.py
from typing import Dict, Union
from django.http import HttpResponse, Http404
from django.shortcuts import render
from django.template import loader
from rest_framework.decorators import api_view
from rest_framework.response import Response


from .models import Cafe
from .serializers import CafeSerializer

# Create your views here.
def index(request):
    return HttpResponse("Hello, world. You're at the cafes index.")


@api_view(["GET"])
def get_random_cafe(request) -> Dict[str, Union[str, bool]]:
    """
    Randomly select a Cafe instance and return its details.
    """
    cafe = Cafe.objects.order_by("?").first()
    if not cafe:
        pass  # API 404?
    serializer = CafeSerializer(cafe)
    return Response(serializer.data)


def detail(request, cafe_id) -> Dict[str, Union[str, bool]]:
    cafe_info = Cafe.objects.filter(id=cafe_id).values().first()
    if not cafe_info:
        raise Http404
    del cafe_info["id"]
    return render(
        request,
        "cafes/detail.html",
        {"name": cafe_info.pop("name"), "info": cafe_info},
    )

django/cafes/templates/cafes/detail.html
{% extends "base.html" %}
{% block title %}{{name}}{% endblock %}
{% block content %}
<h1>Welcome to cafe: {{name}}</h1>
<table>
    {% for key, value in info.items %}
    <tr>
        <th>{{ key }}</th>
        <td>{{ value }}</td>
    </tr>
    {% endfor %}
</table>
<span><a href={% url 'cafes:index' %}>Return to index </a></span>
{% endblock %}

django/templates/base.html
<!DOCTYPE html>
<html lang="en">

    <head>
        <meta charset="utf-8" />
        <title>{% block title %}Sample title{% endblock %}</title>

    </head>

    <body>
        {% block content %}
        <p>This is the default content block</p>
        {% endblock %}
    </body>

</html>